function varargout = bookbot(varargin)
% GUI M-file for gui.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui

% Last Modified by GUIDE v2.5 05-Jun-2012 00:09:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT





% --- Executes just before gui is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui (see VARARGIN)

% silly global variable hack
data = get(handles.figure1, 'UserData');
data.led_g_on=cat(3,zeros(30),0.9*ones(30),zeros(30));
data.led_g_off=cat(3,zeros(30),0.5*ones(30),zeros(30));
data.led_r_on=cat(3,0.9*ones(30),zeros(30),zeros(30));
data.led_r_off=cat(3,0.5*ones(30),zeros(30),zeros(30));
data.stop = false;
set(handles.figure1, 'UserData',data);

% Choose default command line output for gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Arduino Callbacks ---
function arduino_on_Callback(hObject, eventdata, handles)
% connect arduino
data = get(handles.figure1, 'UserData');
set(handles.led_ard,'CData',data.led_g_off);
comPort='COM6';
if ~isempty(instrfind({'Port'},{comPort}))
    set(handles.led_ard,'CData',data.led_g_off);
end
try
    handles.a=arduino(comPort);
    %handles.a=arduino(); % demo mode
    guidata(hObject, handles);
    set(handles.led_ard,'CData',data.led_g_on);
    handles.a.pinMode(2,'input');  % down position button
    handles.a.pinMode(5,'input');  % up position button
    handles.a.pinMode(6,'output'); % motor enable
    handles.a.pinMode(7,'output'); % camera trigger
    handles.a.pinMode(12,'output'); % dc motor pin 1
    handles.a.pinMode(13,'output'); % dc motor pin 2
    handles.a.analogWrite(6,0); % motor enable (0 to 255)
    limit_dn=handles.a.digitalRead(2); % limit switch - platen contacting book
    limit_up=handles.a.digitalRead(5); % limit switch - platen at top of travel
    if(limit_up)
        set(handles.led_up,'CData',data.led_g_on);
    elseif(limit_dn)
        set(handles.led_dn,'CData',data.led_g_on);
    else
        set(handles.led_mid,'CData',data.led_g_on);
    end
    handles.a.servoAttach(1);
    handles.a.servoAttach(2);
    handles.a.servoAttach(3);
    handles.a.servoAttach(4); 
    servo(handles,1,'retract');
    servo(handles,2,'retract');
    servo(handles,3,'retract');
    servo(handles,4,'retract');
    set(handles.led_servos,'CData',data.led_g_on);
    set(handles.auto_start,'Enable','on');
    set(handles.platen_up,'Enable','on');
    set(handles.platen_dn,'Enable','on');
    set(handles.cam_trigger,'Enable','on');
    set(handles.servos_on,'Enable','on');
    set(handles.servos_off,'Enable','on');
    set(handles.servos_retract,'Enable','on');
    set(handles.servos_cycle,'Enable','on');
    set(handles.servo1_down,'Enable','on');
    set(handles.servo1_idle,'Enable','on');
    set(handles.servo1_retract,'Enable','on');
    set(handles.servo1_balance,'Enable','on');
    set(handles.servo1_demo,'Enable','on');
    set(handles.servo2_push,'Enable','on');
    set(handles.servo2_retract,'Enable','on');
    set(handles.servo3_up,'Enable','on');
    set(handles.servo3_idle,'Enable','on');
    set(handles.servo3_down,'Enable','on');
    set(handles.servo4_in,'Enable','on');
    set(handles.servo4_out,'Enable','on');
    data = get(handles.figure1, 'UserData');
    data.stop = false;
    set(handles.figure1, 'UserData',data);
catch
    if ~isempty(instrfind({'Port'},{comPort}))
        set(handles.led_ard,'CData',data.led_g_on);
    else
        set(handles.led_ard,'CData',data.led_r_on);
        pause(0.25);
        set(handles.led_ard,'CData',data.led_r_off);
    end
end

function arduino_off_Callback(hObject, eventdata, handles)
% close arduino session
%fclose(handles.a);
data = get(handles.figure1, 'UserData');
delete(handles.a);
handles = rmfield(handles,'a');
set(handles.led_ard,'CData',data.led_r_on);
pause(0.25);
set(handles.led_ard,'CData',data.led_r_off);



% --- Start Automated Scanning ---
function auto_start_Callback(hObject, eventdata, handles)
data = get(handles.figure1, 'UserData');
if isfield(handles,'a')
    data = get(handles.figure1, 'UserData');
    data.stop = false;
    set(handles.figure1, 'UserData',data);    % initialize everything
    handles.a.servoAttach(1);
    handles.a.servoAttach(2);
    handles.a.servoAttach(3);
    handles.a.servoAttach(4); 
    set(handles.led_servos,'CData',data.led_g_on);
    set(handles.status_up,'CData',data.led_g_off);
    set(handles.status_turn,'CData',data.led_g_off);
    set(handles.status_down,'CData',data.led_g_off);
    set(handles.status_photo,'CData',data.led_g_off);
    set(handles.page_current,'Enable','off');
    set(handles.page_total,'Enable','off');
    set(handles.auto_start,'Enable','off');
    set(handles.auto_stop,'Enable','on');
    set(handles.platen_up,'Enable','off');
    set(handles.platen_dn,'Enable','off');
    set(handles.cam_trigger,'Enable','off');
    set(handles.servos_on,'Enable','off');
    set(handles.servos_off,'Enable','off');
    set(handles.servos_retract,'Enable','off');
    set(handles.servos_cycle,'Enable','off');
    set(handles.servo1_down,'Enable','off');
    set(handles.servo1_idle,'Enable','off');
    set(handles.servo1_retract,'Enable','off');
    set(handles.servo1_balance,'Enable','off');
    set(handles.servo1_demo,'Enable','off');
    set(handles.servo2_push,'Enable','off');
    set(handles.servo2_retract,'Enable','off');
    set(handles.servo3_up,'Enable','off');
    set(handles.servo3_idle,'Enable','off');
    set(handles.servo3_down,'Enable','off');
    set(handles.servo4_in,'Enable','off');
    set(handles.servo4_out,'Enable','off');
    
    limit_dn=handles.a.digitalRead(2); % limit switch - platen contacting book
    limit_up=handles.a.digitalRead(5); % limit switch - platen at top of travel
    set(handles.led_up,'CData',data.led_g_off);
    set(handles.led_mid,'CData',data.led_g_off);
    set(handles.led_dn,'CData',data.led_g_off);
    
    % retract servos
    servo(handles,1,'retract');
    servo(handles,2,'retract');
    servo(handles,3,'retract');
    servo(handles,4,'retract');
    % check for stop
    data = get(handles.figure1, 'UserData');
    if ~data.stop
        if(limit_dn)
            set(handles.led_dn,'CData',data.led_g_on);
        elseif(limit_up)
            set(handles.led_up,'CData',data.led_g_on);
            platen_dn(handles)
        else
            set(handles.led_mid,'CData',data.led_g_on);
            platen_dn(handles)
        end
    end
    
    n=get(handles.page_total,'Value');
    clc;
    time_start=clock;
    
    % % % % % % %
    % MAIN LOOP %
    % % % % % % %
    for i=get(handles.page_current,'Value')-1:n
        % advance string
        set(handles.page_current,'Value',i);
        set(handles.page_current,'String',num2str(get(handles.page_current,'Value')));
        fprintf(['\npage=' num2str(i) '/' num2str(n) '\n']);
        
        % set timer
        time_s=fix(rem(etime(clock,time_start),60));
        time_m=fix(etime(clock,time_start)/60);
        time_h=fix(etime(clock,time_start)/360);
        if time_h == 0 && time_m == 0
            set(handles.text_time,'String',[num2str(time_s) 's']);
        elseif time_h == 0
            set(handles.text_time,'String',[num2str(time_m) 'm ' num2str(time_s) 's']);
        else
            set(handles.text_time,'String',[num2str(time_h) 'h ' num2str(time_m) 'm ' num2str(time_s) 's']);
        end
        
        pause(1);
        
        % take photo
        fprintf('taking photos\n');
        set(handles.status_up,'CData',data.led_g_off);
        set(handles.status_turn,'CData',data.led_g_off);
        set(handles.status_down,'CData',data.led_g_off);
        set(handles.status_photo,'CData',data.led_g_on);
        handles.a.pinMode(7,'output');
        handles.a.digitalWrite(7,1);
        pause(0.2);
        handles.a.digitalWrite(7,0);
        
        pause(2);

        % check for stop
        data = get(handles.figure1, 'UserData');
        if data.stop
            break;
        end
        fprintf('raising platen\n');
        set(handles.status_up,'CData',data.led_g_on);
        set(handles.status_turn,'CData',data.led_g_off);
        set(handles.status_down,'CData',data.led_g_off);
        set(handles.status_photo,'CData',data.led_g_off);
        platen_up(handles)
        
        % check for stop
        data = get(handles.figure1, 'UserData');
        if data.stop
            break;
        end
        fprintf('turning page\n');
        set(handles.status_up,'CData',data.led_g_off);
        set(handles.status_turn,'CData',data.led_g_on);
        set(handles.status_down,'CData',data.led_g_off);
        set(handles.status_photo,'CData',data.led_g_off);
        servos_cycle(handles);
        
        % check for stop
        data = get(handles.figure1, 'UserData');
        if data.stop
            break;
        end
        fprintf('lowering platen\n');
        set(handles.status_up,'CData',data.led_g_off);
        set(handles.status_turn,'CData',data.led_g_off);
        set(handles.status_down,'CData',data.led_g_on);
        set(handles.status_photo,'CData',data.led_g_off);
        platen_dn(handles)
    end
    all_off(handles);
end


% --- Stop Automated Scanning ---
function auto_stop_Callback(hObject, eventdata, handles)
all_off(handles);


function all_off(handles)
data = get(handles.figure1, 'UserData');
data.stop = true;
set(handles.figure1, 'UserData',data);
handles.a.analogWrite(6,0); % 0 to 255 (PWM cycle)
handles.a.digitalWrite(12,0);
handles.a.digitalWrite(13,0);
handles.a.servoDetach(1);
handles.a.servoDetach(2);
handles.a.servoDetach(3);
handles.a.servoDetach(4); 

limit_dn=handles.a.digitalRead(2); % limit switch - platen contacting book
limit_up=handles.a.digitalRead(5); % limit switch - platen at top of travel
set(handles.led_up,'CData',data.led_g_off);
set(handles.led_mid,'CData',data.led_g_off);
set(handles.led_dn,'CData',data.led_g_off);
if(limit_up)
    set(handles.led_up,'CData',data.led_g_on);
elseif(limit_dn)
    set(handles.led_dn,'CData',data.led_g_on);
else
    set(handles.led_mid,'CData',data.led_g_on);
end

set(handles.status_up,'CData',data.led_r_off);
set(handles.status_turn,'CData',data.led_r_off);
set(handles.status_down,'CData',data.led_r_off);
set(handles.status_photo,'CData',data.led_r_off);
set(handles.page_current,'Enable','on');
set(handles.page_total,'Enable','on');
set(handles.auto_start,'Enable','on');
set(handles.platen_up,'Enable','on');
set(handles.platen_dn,'Enable','on');
set(handles.cam_trigger,'Enable','on');
set(handles.servos_on,'Enable','on');
set(handles.servos_off,'Enable','on');
set(handles.servos_retract,'Enable','off');
set(handles.servos_cycle,'Enable','off');
set(handles.servo1_down,'Enable','off');
set(handles.servo1_idle,'Enable','off');
set(handles.servo1_retract,'Enable','off');
set(handles.servo1_balance,'Enable','off');
set(handles.servo1_demo,'Enable','off');
set(handles.servo2_push,'Enable','off');
set(handles.servo2_retract,'Enable','off');
set(handles.servo3_up,'Enable','off');
set(handles.servo3_idle,'Enable','off');
set(handles.servo3_down,'Enable','off');
set(handles.servo4_in,'Enable','off');
set(handles.servo4_out,'Enable','off');
set(handles.led_servos,'CData',data.led_g_off);



% --- Automation Text Boxes ---
function page_current_Callback(hObject, eventdata, handles)
% hObject    handle to page_current (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of page_current as text
%        str2double(get(hObject,'String')) returns contents of page_current as a double
x=floor(str2double(get(handles.page_current,'String')));
if ~isempty(x) && ~isnan(x)
    set(handles.page_current,'Value',x);
end
set(handles.page_current,'String',num2str(get(handles.page_current,'Value')));

% --- Executes during object creation, after setting all properties.
function page_current_CreateFcn(hObject, eventdata, handles)
% hObject    handle to page_current (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'Value',1);
set(hObject,'String',num2str(get(hObject,'Value')));

function page_total_Callback(hObject, eventdata, handles)
% hObject    handle to page_total (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of page_total as text
%        str2double(get(hObject,'String')) returns contents of page_total as a double
x=floor(str2double(get(handles.page_total,'String')));
if ~isempty(x) && ~isnan(x)
    set(handles.page_total,'Value',x);
end
set(handles.page_total,'String',num2str(get(handles.page_total,'Value')));

% --- Executes during object creation, after setting all properties.
function page_total_CreateFcn(hObject, eventdata, handles)
% hObject    handle to page_total (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'Value',100);
set(hObject,'String',num2str(get(hObject,'Value')));



% --- Executes on button press in platen_up.
function platen_up_Callback(hObject, eventdata, handles)
% hObject    handle to platen_up (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.figure1, 'UserData');
if isfield(handles,'a')
    data.stop = false;
    set(handles.figure1, 'UserData',data);
    platen_up(handles);
else
    pause(0.2);
    set(handles.led_up,'CData',data.led_g_off);
    set(handles.led_dn,'CData',data.led_g_off);
    set(handles.led_mid,'CData',data.led_g_on);
    pause(0.5);
    set(handles.led_mid,'CData',data.led_g_off);
    set(handles.led_up,'CData',data.led_g_on);
end

% --- Executes on button press in platen_dn.
function platen_dn_Callback(hObject, eventdata, handles)
data = get(handles.figure1, 'UserData');
if isfield(handles,'a')
    data.stop = false;
    set(handles.figure1, 'UserData',data);
    platen_dn(handles);
else
    pause(0.2);
    set(handles.led_up,'CData',data.led_g_off);
    set(handles.led_mid,'CData',data.led_g_on);
    set(handles.led_dn,'CData',data.led_g_off);
    pause(0.5);
    set(handles.led_mid,'CData',data.led_g_off);
    set(handles.led_dn,'CData',data.led_g_on);
end



% --- Raise Platen ---
function platen_up(handles)
data = get(handles.figure1, 'UserData');
set(handles.led_up,'CData',data.led_g_off);
set(handles.led_mid,'CData',data.led_g_on);
set(handles.led_dn,'CData',data.led_g_off);
limit_up=handles.a.digitalRead(5); % limit switch - platen at top of travel
tic;

if ~data.stop
    handles.a.analogWrite(6,255); % 0 to 255 (PWM cycle)
    handles.a.digitalWrite(12,1);
    handles.a.digitalWrite(13,0);
end
while (toc < 0.75) && ~limit_up && ~data.stop
    limit_up=handles.a.digitalRead(5);
    data = get(handles.figure1, 'UserData');
end
% reduce motor speed after 0.75 seconds
handles.a.analogWrite(6,200); % 0 to 255 (PWM cycle)
pause(0.05);
while (toc < 2.5) && ~limit_up && ~data.stop
    limit_up=handles.a.digitalRead(5);
    data = get(handles.figure1, 'UserData');
    pause(0.05);
end
% motor off after 2.5 seconds or when limit switch is hit
handles.a.analogWrite(6,0); % 0 to 255 (PWM cycle)
handles.a.digitalWrite(12,0);
handles.a.digitalWrite(13,0);

% gui lights
if limit_up
    set(handles.led_mid,'CData',data.led_g_off);
    set(handles.led_up,'CData',data.led_g_on);
else
    set(handles.led_up,'CData',data.led_r_on);
    set(handles.led_mid,'CData',data.led_r_on);
    set(handles.led_dn,'CData',data.led_r_on);
    pause(0.25)
    set(handles.led_up,'CData',data.led_r_off);
    set(handles.led_mid,'CData',data.led_r_off);
    set(handles.led_dn,'CData',data.led_r_off);
    pause(0.25)
    set(handles.led_up,'CData',data.led_r_on);
    set(handles.led_mid,'CData',data.led_r_on);
    set(handles.led_dn,'CData',data.led_r_on);
end


% --- Lower Platen ---
function platen_dn(handles)
data = get(handles.figure1, 'UserData');
set(handles.led_up,'CData',data.led_g_off);
set(handles.led_mid,'CData',data.led_g_on);
set(handles.led_dn,'CData',data.led_g_off);
limit_dn=handles.a.digitalRead(2); % limit switch - platen contacting book
tic;

if ~data.stop
    handles.a.analogWrite(6,255); % 0 to 255 (PWM cycle)
    handles.a.digitalWrite(12,0);
    handles.a.digitalWrite(13,1);
end
pause(0.1);
while (toc < 0.5) && ~limit_dn && ~data.stop
    limit_dn=handles.a.digitalRead(2);
    data = get(handles.figure1, 'UserData');
    pause(0.1);
end

% reduce motor speed
while (toc < 2) && ~limit_dn && ~data.stop
    limit_dn=handles.a.digitalRead(2);
    data = get(handles.figure1, 'UserData');
    pause(0.1);
end
%motor off after 2.5 seconds or when limit switch is hit
handles.a.analogWrite(6,0); % 0 to 255 (PWM cycle)
handles.a.digitalWrite(12,0);
handles.a.digitalWrite(13,0);

% gui lights
if limit_dn
    set(handles.led_mid,'CData',data.led_g_off);
    set(handles.led_dn,'CData',data.led_g_on);
else
    set(handles.led_up,'CData',data.led_r_on);
    set(handles.led_mid,'CData',data.led_r_on);
    set(handles.led_dn,'CData',data.led_r_on);
    pause(0.25)
    set(handles.led_up,'CData',data.led_r_off);
    set(handles.led_mid,'CData',data.led_r_off);
    set(handles.led_dn,'CData',data.led_r_off);
    pause(0.25)
    set(handles.led_up,'CData',data.led_r_on);
    set(handles.led_mid,'CData',data.led_r_on);
    set(handles.led_dn,'CData',data.led_r_on);
end



% --- Camera Callback ---
function cam_trigger_Callback(hObject, eventdata, handles)
handles.a.pinMode(7,'output');
handles.a.digitalWrite(7,1);
pause(0.2);
handles.a.digitalWrite(7,0);



% --- Servo Collective Callbacks ---
function servos_on_Callback(hObject, eventdata, handles)
if isfield(handles,'a')
    data = get(handles.figure1, 'UserData');
    data.stop = false;
    set(handles.figure1, 'UserData',data);
    handles.a.servoAttach(1);
    handles.a.servoAttach(2);
    handles.a.servoAttach(3);
    handles.a.servoAttach(4); 
    set(handles.led_servos,'CData',data.led_g_on);
    set(handles.servos_retract,'Enable','on');
    set(handles.servos_cycle,'Enable','on');
    set(handles.servo1_down,'Enable','on');
    set(handles.servo1_idle,'Enable','on');
    set(handles.servo1_retract,'Enable','on');
    set(handles.servo1_balance,'Enable','on');
    set(handles.servo1_demo,'Enable','on');
    set(handles.servo2_push,'Enable','on');
    set(handles.servo2_retract,'Enable','on');
    set(handles.servo3_up,'Enable','on');
    set(handles.servo3_idle,'Enable','on');
    set(handles.servo3_down,'Enable','on');
    set(handles.servo4_in,'Enable','on');
    set(handles.servo4_out,'Enable','on');
end

function servos_off_Callback(hObject, eventdata, handles)
data = get(handles.figure1, 'UserData');
if isfield(handles,'a')
    handles.a.servoDetach(1);
    handles.a.servoDetach(2);
    handles.a.servoDetach(3);
    handles.a.servoDetach(4); 
end
set(handles.led_servos,'CData',data.led_g_off);
set(handles.servos_retract,'Enable','off');
set(handles.servos_cycle,'Enable','off');
set(handles.servo1_down,'Enable','off');
set(handles.servo1_idle,'Enable','off');
set(handles.servo1_retract,'Enable','off');
set(handles.servo1_balance,'Enable','off');
set(handles.servo1_demo,'Enable','off');
set(handles.servo2_push,'Enable','off');
set(handles.servo2_retract,'Enable','off');
set(handles.servo3_up,'Enable','off');
set(handles.servo3_idle,'Enable','off');
set(handles.servo3_down,'Enable','off');
set(handles.servo4_in,'Enable','off');
set(handles.servo4_out,'Enable','off');

function servos_retract_Callback(hObject, eventdata, handles)
servo(handles,1,'retract');
servo(handles,2,'retract');
servo(handles,3,'retract');
servo(handles,4,'retract');

function servos_cycle_Callback(hObject, eventdata, handles)
servos_cycle(handles);



% --- Servo #1 Individual Callbacks ---
function servo1_down_Callback(hObject, eventdata, handles)
servo(handles,1,'down_sea');
function servo1_idle_Callback(hObject, eventdata, handles)
servo(handles,1,'idle');
function servo1_retract_Callback(hObject, eventdata, handles)
servo(handles,1,'retract');
function servo1_balance_Callback(hObject, eventdata, handles)
servo(handles,1,'balance');
function servo1_demo_Callback(hObject, eventdata, handles)
servo(handles,1,'demo');



% --- Servo #2 Individual Callbacks ---
function servo2_push_Callback(hObject, eventdata, handles)
servo(handles,2,'push');
function servo2_retract_Callback(hObject, eventdata, handles)
servo(handles,2,'retract');



% --- Servo #3 Individual Callbacks ---
function servo3_up_Callback(hObject, eventdata, handles)
servo(handles,3,'up');
function servo3_idle_Callback(hObject, eventdata, handles)
servo(handles,3,'idle');
function servo3_down_Callback(hObject, eventdata, handles)
servo(handles,3,'down');



% --- Servo #4 Individual Callbacks ---
function servo4_in_Callback(hObject, eventdata, handles)
servo(handles,4,'in');
function servo4_out_Callback(hObject, eventdata, handles)
servo(handles,4,'out');



% --- Turn Page with Servos ---
function servos_cycle(handles)
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,1,'down_sea'); pause(0.25);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,2,'push');     
    servo(handles,3,'idle');     pause(1);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,4,'in');       pause(0.75);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,1,'idle');     pause(0.25);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,2,'back');     
    servo(handles,3,'up');       pause(0.75);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,1,'up');       
    servo(handles,4,'out');      pause(0.75);
end
data = get(handles.figure1, 'UserData');
if ~data.stop
    servo(handles,3,'down');     pause(0.5);
end


% --- Move Servo to Position ---
function servo(handles,num,command)
%SERVO actuates page turning servos
% a = arduino object
% num = servo number (1 through 4)
% command = up, down, etc.; servo specific

error = 0; % input command error tracking flag
sea = 0;   % flag for series elastic control loop mode

if num == 1 % arm up/down
    if strcmp(command,'balance')
        angle = 106;
    elseif strcmp(command,'idle')
        angle = 80;
    elseif strcmp(command,'down')
        angle = 45;
    elseif strcmp(command,'down_sea')
        angle = 45;
        sea = 1;
    elseif strcmp(command,'demo')
        angle = 45;
        sea = 3;
    elseif strcmp(command,'up') || strcmp(command,'retract')
        angle = 129;
    else
        error = 1;
    end
elseif num == 2 % arm push
    if strcmp(command,'push')
        angle = 113;
    elseif strcmp(command,'push_sea')
        angle = 113;
        sea = 2;
    elseif strcmp(command,'back') || strcmp(command,'idle') || strcmp(command,'retract')
        angle = 33;
    else
        error = 1;
    end
elseif num == 3 % rod up/down
    %close position: idle=60, up=160, down=18
    %mid position: idle=90, up=165, down=55
    if strcmp(command,'idle')
        angle = 70;
    elseif strcmp(command,'up')
        angle = 160;
    elseif strcmp(command,'down') || strcmp(command,'retract')
        angle = 18;
    else
        error = 1;
    end
elseif num == 4 % rod in/out
    if strcmp(command,'in')
        angle = 80;
    elseif strcmp(command,'out') || strcmp(command,'idle') || strcmp(command,'retract')
        angle = 145;
    else
        error = 1;
    end
else % invalid num
    error = 1;
end

if error == 0 && sea == 0
    % MOVE SERVO
    handles.a.servoWrite(num,angle);
elseif error == 0 && sea == 1
    % series elastic mode: arm-down
    % potentiometer analog pin value from arduino: 0-1023
    % P/N: P230-1FD20BR10K w/ 300deg rotation (~0.3deg resolution)
    pot_goal=392; % potentiometer value at desired force
    pot_idle=344; % potentiometer value at zero force
    error_max=3;  % error threshhold
    error_cycles=0; % counter for cycles within error threshhold
    pid_p=0.05;
    pid_i=0.1;
    pid_d=0.2;
    error_p=0;
    error_i=0;
    time_pause=0.1;
    tic;
    set(handles.text_pot,'ForegroundColor',[0 0 0]);
    
    %fprintf('\n');
    while (toc < 3.5) && error_cycles < 3
        pot_current=handles.a.analogRead(0); % read pot value
        error_p=pot_goal-pot_current;  % calculate error
        if exist('error_old','var')
            error_d=error_p-error_old;
        else
            error_d=0;
        end
        error_i=error_i+error;
        if error_i > 30
            error_i = 30;
        end
        error=error_p*pid_p + error_d*pid_d + error_i*pid_i;
        if abs(error) > error_max && pot_current > pot_idle
            % set new goal angle, if arm is in contact with page
            angle = round(angle - error);
            %fprintf(['angle=' num2str(angle) ' p=' num2str(0.1*round(10*error_p*pid_p)) ' i=' num2str(0.1*round(10*error_i*pid_i)) ' d=' num2str(0.1*round(10*error_d*pid_d)) '\n']);
        end
        if angle < 24
            angle = 24; end
        if angle > 120
            angle = 120; end
        set(handles.text_pot,'String',num2str(0.1*round(10*error)));
        handles.a.servoWrite(1,angle);
        if abs(error) <= error_max
            error_cycles = error_cycles + 1;
        else
            error_cycles = 0;
        end
        error_old=error_p;
        pause(time_pause);
    end
    if error_cycles < 3
        set(handles.text_pot,'ForegroundColor',[1 0 0]);
    else
        set(handles.text_pot,'ForegroundColor',[0 0.7 0]);
    end
    set(handles.text_pot,'String',[num2str(0.1*round(10*error)) ' (' num2str(0.1*fix(10*toc)) 's)']);
    %set(handles.text_pot_t,'String',num2str(0.1*fix(10*toc)));
elseif error == 0 && sea == 3
    % DEMO MODE
    % series elastic mode: arm-down
    % potentiometer analog pin value from arduino: 0-1023
    % P/N: P230-1FD20BR10K w/ 300deg rotation (~0.3deg resolution)
    pot_goal=392; % potentiometer value at desired force
    pot_idle=344; % potentiometer value at zero force
    error_max=2;  % error threshhold
    pid_p=0.15;
    pid_i=0.1;
    pid_d=0.2;
    error_p=0;
    error_i=0;
    time_pause=0.05;
    set(handles.text_pot,'ForegroundColor',[0 0 0]);
    limit_dn=handles.a.digitalRead(2); % limit switch - platen contacting book
    
    fprintf('\n');
    data = get(handles.figure1, 'UserData');
    while ~data.stop
        pot_current=handles.a.analogRead(0); % read pot value
        error_p=pot_goal-pot_current;  % calculate error
        if exist('error_old','var')
            error_d=error_p-error_old;
        else
            error_d=0;
        end
        error_i=error_i+error;
        if error_i > 30
            error_i = 30;
        end
        error=error_p*pid_p;% + error_d*pid_d + error_i*pid_i;
        if abs(error) > error_max && pot_current > pot_idle
            % set new goal angle, if arm is in contact with page
            angle = round(angle - error);
            fprintf(['angle=' num2str(angle) ' p=' num2str(0.1*round(10*error_p*pid_p)) ' i=' num2str(0.1*round(10*error_i*pid_i)) ' d=' num2str(0.1*round(10*error_d*pid_d)) '\n']);
        end
        if angle < 24
            angle = 24; end
        if angle > 120
            angle = 120; end
        set(handles.text_pot,'String',num2str(0.1*round(10*error)));
        handles.a.servoWrite(1,angle);
        error_old=error_p;
        pause(time_pause);
        data = get(handles.figure1, 'UserData');
    end
elseif error == 0 && sea == 2
    % series-elastic mode: arm-push
    % NOT IMPLEMENTED
end
