@title BookBot
@param z zoom index
@default z 7
@param f focus index
@default f 390
@param a aperture index
@default a 9
@param t shutter index
@default t 20

gosub "get_ready"
do
  print "f=";f,"z=";z,"tv=";t
  print "press [SET] to begin"
  print "(10 second timeout)"
  q=1
  wait_click 10000
  is_key k "left"
    if k=1 then gosub "k_left"
  is_key k "right"
    if k=1 then gosub "k_right"
  is_key k "up"
    if k=1 then gosub "k_up"
  is_key k "down"
    if k=1 then gosub "k_down"
  is_key k "zoom_in"
    if k=1 then gosub "k_zoom_in"
  is_key k "zoom_out"
    if k=1 then gosub "k_zoom_out"
  is_key k "shoot_half"
    if k=1 then gosub "k_focus"
  is_key k "erase"
    if k=1 then goto "enter_play_mode"
  is_key k "set"
    if k=1 then q=1
  gosub "switch_to_rec"
  cls
until q=1
goto "loop"
end


:loop
  print "waiting for USB signal"
  do
    if get_mode then
      gosub "get_ready"
      print "waiting for USB signal"
    endif
  until is_pressed "remote"
  print "signal received"
  i=0
  p=0
  while i<30 do
    if is_pressed "remote" then
      i=i+1
    else
      p=i
      i=30
    endif
  wend
  if p=0 then
    print "switching to USB data"
    set_config_value 121 0
  else
    print "shutter triggered"
    click "shoot_full"
    sleep 3000
  endif
  cls
goto "loop"



:get_ready
if get_mode then
  print "playback mode detected"
  while get_mode do
    set_record(1)
    sleep 50
  wend
  print "switched to record mode"
else
  print "in record mode"
endif

get_config_value 121 x y
if y = 0 then
  print "turning on USB remote"
  set_config_value 121 1
else
  print "USB remote is on"
endif

get_prop 49 x
y=x
while not x=-32767 do
  cls
  get_prop 49 x
  print "set mode dial to M"
  sleep 100
wend
if not y=-32767 then
  click "shoot_half"
  sleep 500
else
  print "dial is at M mode"
endif

get_prop 6 x
while not x=4 do
  click "left"
  sleep 200
  click "left"
  sleep 100
  click "set"
  sleep 200
  get_prop 6 x
wend
print "manual focus set"
sleep 100

print "setting iso av tv"
set_iso 1
set_av a
set_tv t
sleep 100
print "setting zoom",z
set_zoom z
sleep 1000
print "setting focus",f
set_focus f
sleep 1000
get_av a
get_user_tv_id t
get_zoom z
get_focus f
click "shoot_half"
sleep 1000
cls
return


:switch_to_rec
if get_mode then b=1 else b=0 endif
while get_mode do
  set_record(1)
  sleep(50)
wend
if b then gosub "get_ready"
return


:switch_remote
if not get_config_value(121) then
  set_config_value(121, 1)
  print("turning remote on")
else
  set_config_value(121, 0)
  print("turning remote off")
endif
sleep(1000)
return


:k_left
print "focus-"
f=f-25
set_focus f
sleep 50
get_focus f
q=0
return


:k_right
print "focus+"
f=f+25
set_focus f
sleep 50
get_focus f
q=0
return


:k_up
print "tv+"
t=t+1
set_tv t
sleep 50
get_user_tv_id t
q=0
return


:k_down
print "tv-"
t=t-1
set_tv t
sleep 50
get_user_tv_id t
q=0
return


:k_zoom_in
print "zoom+"
z=z+1
set_zoom z
sleep 50
get_zoom z
q=0
return


:k_zoom_out
print "zoom-"
z=z-1
set_zoom z
sleep 50
get_zoom z
q=0
return


:k_focus
get_prop 6 x
while not x=0 do
  click "left"
  sleep 200
  click "left"
  sleep 100
  click "set"
  sleep 200
  get_prop 6 x
wend
print "autofocusing"
sleep 100
set_aflock 0
press "shoot_half"
sleep 1000
release "shoot_half"
sleep 1000
while not x=4 do
  click "left"
  sleep 200
  click "left"
  sleep 100
  click "set"
  sleep 200
  get_prop 6 x
wend
print "manual focus set"
get_focus f
sleep 1000
q=0
return


:enter_play_mode
print "entering play mode"
set_aflock 0
sleep 50
set_record(0)
exit_alt
end